package webui

import (
    "fmt"
	"log"
	"net/http"
    "gitea.armuli.eu/museum-digital/museum-digital-webdav-uploader/src/configloader"
)

var config configloader.MDWebDavUploaderConfig
var setupRequired bool

// Sets up the server and manages routing.
func Run() {

    config, setupRequired, _ = configloader.LoadFromFile("")

	// Bind callable URLs
	http.HandleFunc("/", serveAppShell)                         // Serve app shell
	http.HandleFunc("/get-settings", serveApiGetSettings)       // API for listing current settings
	http.HandleFunc("/list-uploadable", serveApiListUploadable) // API to list uploadable files
	http.HandleFunc("/list-parsers", serveApiListParsers)       // API to list available parsers.
    http.HandleFunc("/update-settings", serveApiUpdateSettings) // API for updating settings
	// http.HandleFunc("/trigger-upload", serveFilePage)           // Serve page for specific files
	// http.HandleFunc("/contribute.json", )                // Serve page for specific files
	http.HandleFunc("/md-uploader.css", serveCss)        // Main CSS file.
	http.HandleFunc("/md-uploader.js", serveJs)          // Main JS file.
	http.HandleFunc("/logo.svg", serveLogo)              // Logo.

    port := "8080"

	// Set port to listen on
    fmt.Println("Server started at port " + string(port))
	err := http.ListenAndServe(":"+port, nil)
	if err != nil {
		log.Fatal("ListenAndServe: ", err)
	}

}
